; MM 10
;-------------------
Include "readmap.bb"

Const OPENING = 10, OPENED  = 20, CLOSING = 30, CLOSED  = 40
Const SYNBOLS_PER_PAGE = 60

Graphics3D 640, 480 , 32, 2
SetBuffer BackBuffer()

Const TypePlayer = 1, TypeWall = 2, TypeDoor = 3, TypeNPC = 4, TypeShip = 5
Global distance# = 0
;Fonts
Global Font1, Font2, imY%
Font1 = LoadFont("Courier",16)
Font2 = LoadFont("Courier",12)

Global deck

Global fRate
init_fpslimit(5)

;Global sndWave=LoadSound("Sounds\bgmusic.mp3") 
Global chnMIDI=PlayMusic("Sounds\theme1.mid") 
ChannelVolume chnMIDI, 0.2

; Prepare the sound for looping 
;LoopSound sndWave
;SoundVolume sndWave, 0.1
;Global chnWave=PlaySound(sndWave) 

Dim Inventory%(20)  
Global LeftInvPos = 0
Global lInGame = True
;QUEST FLAGS
Global lPortalMode = False
Global lDialogMode = False
Global cDialogText$ = ""
Dim aFlags%(20)
aFlags(0) = 0    
Global gfxStatus = LoadImage("status.bmp") 

Global gfxDialogSRC = LoadImage("dialog.bmp")
Global gfxDialogDST = CreateImage(640,118) 

; Items
Type itemsinfo
    Field oItem%
    Field ItemModel%
    Field ItemID$
    Field ItemName$
    Field ItemDescription$
End Type
Global ALL_ITEMS = 30;
Dim Items.itemsinfo( ALL_ITEMS )
Global cFound$, NumItems = 0
Global cInvPos$
Global lItemInHand = False, CurrentItem%, CurrentModel% 


;NPC
Type npcinfo
    Field oNPC%
    Field NPCModel%
    Field NPCID$
    Field status%   
    Field NPCName$
    Field QuestFile$
    Field QuestFlag%
    Field Image$
End Type
Global ALL_NPC = 30; Number of NPC
Dim Npc.npcinfo( ALL_NPC )
Global NumNpc = 0

; Doors 
Type doorsinfo
    Field ix%,iz%
    Field oDoor%
    Field Pivot
    Field status%
    Field pos#
    Field doortype% ;  VDOOR, HDOOR
    Field Delay%
    Field ticks#
    Field DoorName$ 
End Type
Global ALL_DOORS = 30 ; number of doors
Dim Doors.doorsinfo( ALL_DOORS )
Global NumDoors = 0


;====================
Dim aStr$(100)
Global iNumStr%

Global lWire = False

Global player=CreateSphere()
PositionEntity player,799, 1, 802
;PositionEntity player,678, 1, 656

TurnEntity player,0,210,0
EntityRadius player, 3
EntityType player, TypePlayer

Global cam=CreateCamera(player)

CameraRange cam,0.1,4000
CameraFogMode cam,1
CameraFogColor cam,10,10,50
CameraClsColor cam,10,10,50
CameraFogRange cam,10,1200

light=CreateLight(0)
RotateEntity light,45,0,0


; Load terrain
Global terrain=LoadTerrain( "terra.bmp" )
NameEntity terrain, "FLOOR"
EntityPickMode terrain, 2
; Set terrain detail, enable vertex morphing
TerrainDetail terrain,4000,True

; Scale terrain
ScaleEntity terrain,6,80,6

; Texture terrain
grass_tex=LoadTexture( "terra_tex.bmp" )
detail=LoadTexture( "tex4.png" )
EntityTexture terrain,detail,0,1
EntityTexture terrain,grass_tex,0,2
ScaleTexture grass_tex, 256,256
ScaleTexture detail, 2,2

; Water
Global watermesh=LoadMesh("20x20mesh.3ds")  
RotateMesh watermesh,90,0,0 
RotateEntity watermesh,-90,0,0
ScaleEntity watermesh,10,10,10
PositionEntity watermesh, 0,2,0

Global watertexture=LoadAnimTexture("wateranim.jpg",256,124,124,0,25)
EntityTexture watermesh,watertexture,0,1
ScaleTexture watertexture,.01,.01
EntityShininess watermesh,0.2
EntityAlpha watermesh, 0.5
EntityFX watermesh, 16

;HideEntity terrain
;HideEntity watermesh

	;Tree
	tree = LoadMesh("MODELS\TREES\tree.B3D")
	FlipMesh tree
	ScaleEntity tree, 0.08, 0.08, 0.08
	PositionEntity tree,0,0,0
	EntityFX tree, 16+1
	EntityPickMode tree,1
	HideEntity tree
	
level = LoadCSM("mist_isle.csm","Textures\")
ScaleEntity level, 0.06, 0.06, 0.06
PositionEntity level, 740, 10, 700
;TurnEntity level, 0,180,0

SeedRnd MilliSecs()


; Ship

     Global shiptex = LoadTexture("Models\ship.jpg")
     Npc(NumNpc) = New npcinfo
     Npc(NumNpc)\NpcName   = "door" 
     Npc(NumNpc)\NpcModel  = LoadMD2("Models\ship1t.md2") 
     PositionEntity Npc(NumNpc)\NpcModel, 850, 2, 859
     TurnEntity Npc(NumNpc)\NpcModel, 0, 180, 0
     ScaleEntity Npc(NumNpc)\NpcModel, 1.5, 1.5, 1.5
     AnimateMD2 Npc(NumNpc)\NpcModel, 1, 0.05, 1, 1   ; 24
     EntityTexture Npc(NumNpc)\NpcModel, shiptex

     EntityType Npc(NumNpc)\NpcModel, TypeShip
     EntityPickMode Npc(NumNpc)\NpcModel,1
     EntityRadius Npc(NumNpc)\NpcModel, 30
     NameEntity Npc(NumNpc)\NpcModel, "class=door"
     Npc(NumNpc)\QuestFile = "captain.qst"
     Npc(NumNpc)\QuestFlag = 6
     Npc(NumNpc)\Image = "captain.jpg"
     NumNpc = NumNpc + 1

     Global listener=CreateListener(cam,0.2,1,1) ; Create listener, make it child of camera 
     Global shipsound=Load3DSound("sounds/boat.wav") ; Load 3D sound 
     Global ShipSoundTime

; Peasant

     Npc(NumNpc) = New npcinfo
     Npc(NumNpc)\NpcName   = "livenpc" 
     Npc(NumNpc)\NpcModel  = LoadAnimMesh("Models\peasant.b3d") 
     PositionEntity Npc(NumNpc)\NpcModel, 557, 8, 346
     ScaleEntity Npc(NumNpc)\NpcModel, 0.1, 0.1, 0.1
     EntityType Npc(NumNpc)\NpcModel, TypeNPC
     EntityPickMode Npc(NumNpc)\NpcModel,2
     EntityRadius Npc(NumNpc)\NpcModel, 20
     NameEntity Npc(NumNpc)\NpcModel, "class=door"+Chr(10)+"name=livenpc"
     Npc(NumNpc)\QuestFile = "levanda.qst"
     Npc(NumNpc)\QuestFlag = 7
     Npc(NumNpc)\Image = "toad.bmp"
     Animate Npc(NumNpc)\NpcModel, 1, 0.05
     TurnEntity Npc(NumNpc)\NpcModel, 0, 120, 0
     NumNpc = NumNpc + 1


AmbientLight 200,200,200

Global waterflow# = 10
Global wavesize# = 0.05

Global surface=GetSurface(watermesh,1)

Global VertexCount=CountVertices(surface)

Type Vertices
	Field x#
	Field y#
	Field z#
End Type

Dim Vertex.Vertices(VertexCount)

For A=0 To VertexCount-1
  Vertex(a) = New Vertices
  Vertex(a)\x#=VertexX#(surface,a)
  Vertex(a)\y#=VertexY#(surface,a)
  Vertex(a)\z#=VertexZ#(surface,a)
Next

Collisions TypePlayer, TypeWall, 2, 2
Collisions TypePlayer, TypeNPC,  2, 1
Collisions TypePlayer, TypeShip, 1, 2

LoadItems("level1.w3d")

Global current = MilliSecs() 




;;;;;;;;;  MAIN   ;;;;;;;;;;;;;;;;;;;;;;;
While Not KeyDown( 1 )

; Toggle terrain shading value between 0 and 1 when spacebar is pressed
If KeyHit(57)=True Then terra_shade=1-terra_shade

; Enable/disable terrain shading
TerrainShading terrain,terra_shade

   If MouseHit(1)=True 
      If (Not CheckInventory(MouseX(), MouseY())) 
      ent = CameraPick(cam,MouseX(),MouseY()) 
      If ent
         ;CFound = Str(ent)
         x1=PickedX()
         y1=PickedY()
         z1=PickedZ()
         CFound = Str(x1)+" : "+Str(y1)+" : "+Str(z1)

         name$ = EntityName(ent)
         class$ = KeyValue$(ent,"class")
         ; if ANY ITEM_ found: KEY, PLANT, WEAPON etc.
         If name = "ITEM" 
            If MinXZDist(player,x1,z1) < 30
            If lItemInHand 
              tmpPic = CurrentItem
              tmpModel = CurrentModel  
              CurrentItem = FindItem( ent )
              CurrentModel = ent
              ShowEntity tmpModel
              CY# = TerrainY(terrain, x1,y1,z1)
              PositionEntity tmpModel, x1,CY+1, z1
              HideEntity ent
            Else    
              lItemInHand = True 	
              CurrentItem = FindItem( ent )
              CurrentModel = ent
              If CurrentItem
                 HideEntity ent
              EndIf
            EndIf 
            EndIf 
            texSec = MilliSecs() 
            cObjectName = FindItemDescription(ent,1)
         EndIf 
         ; Floor/Ground Picked
         If name = "FLOOR" 
            CY# = TerrainY(terrain, x1,y1,z1)
            If lItemInHand 
               ShowEntity CurrentModel
               PositionEntity CurrentModel, x1, CY+1 , z1
               lItemInHand = False 
            EndIf  
         EndIf 
         ; Door Class 
         If class$ = "door" 
            distance = MinXZDist(player, x1,z1)
            If MinXZDist(player, x1,z1) < 20
                ; Who Lives There?  
                name$ = KeyValue$(ent,"name")
                If name = "livenpc"                
                   RotateEntity Npc(NumNpc-1)\NpcModel, 0, EntityYaw(player), 0  
                EndIf
                lDialogMode = True
                NPCDialog(ent)
            EndIf         
         EndIf  
         If class$ = "actdoor" 
            distance = MinXZDist(player, x1,z1)
            If MinXZDist(player, x1,z1) < 15
                ; Activation Door
                quest_name$ = KeyValue$(ent,"name")
                iQuestFlag% = KeyValue$(ent,"questflag")
                For i=0 To 8  
                   item_name$ = FindItemName( Inventory(i) )
                   If quest_name = item_name
                      enterSound = LoadSound("sounds/door.wav")
                      PlaySound(enterSound)
                      aFlags(iQuestFlag) = aFlags(iQuestFlag) + 1
                      OpenActDoors(ent)
                   EndIf 
                Next
            EndIf         
         EndIf  

      EndIf 
      EndIf
   EndIf 

If KeyDown( 205 )=True Then TurnEntity player,0,-2,0
If KeyDown( 203 )=True Then TurnEntity player,0,2,0
If KeyDown( 208 )=True Then MoveEntity player,0,0,-1
If KeyDown( 200 )=True Then MoveEntity player,0,0,1
If KeyHit( 17 )=True  Then lWire = Not lWire

WireFrame lWire
x#=EntityX(player)
y#=EntityY(player)
z#=EntityZ(player)

If ShipSoundTime+7000 < MilliSecs()
   If Not ChannelPlaying( chnMIDI )
      chnMIDI=PlayMusic("Sounds\theme1.mid") 
   EndIf

   EmitSound(shipsound,Npc(NumNpc-2)\NpcModel)
   ShipSoundTime = MilliSecs()
EndIf

;terra_y#=terra_y#-0.5
If EntityCollided(player,TypeNPC)
   RotateEntity Npc(NumNpc-1)\NpcModel, 0, EntityYaw(player), 0  
EndIf
;Else
    terra_y#=TerrainY(terrain,x#,y#,z#)+5
;EndIf

    PositionEntity player,x#,terra_y#,z#

wd=wd+1
If wd=4
  EntityTexture watermesh,watertexture,frame,1
  frame=frame+1
  If frame=22 Then frame=0
  wd=0
EndIf

;  Fog
CameraFogMode cam,1
CameraClsColor cam,255,255,255
CameraFogColor cam,255,255,255
CameraFogRange cam,100,300

UpdateWater()

UpdateDoors()

UpdateWorld
;--------------------------------------------------------------
;put skybox
;--------------------------------------------------------------
PositionEntity sky,EntityX(cam,True),EntityY(cam,True)-100,EntityZ(cam,True)

RenderWorld
   DrawInventory()
   If lItemInHand 
      DrawImage(CurrentItem, MouseX()-25, MouseY()-15 )
   EndIf 

;Text 0,0, CFound$
;Text 0,0, Str(distance);
;Text 0, 20, Str(EntityX(player))+" "+Str(EntityZ(player) )+" Alpha: "+Str(EntityYaw(player))

Flip
limitfps()

Wend

End


;======== Frames LIMIT 
Function init_FPSLimit(f)
	frate=(1000/f)
	ftime1 = MilliSecs() 
End Function

Function LimitFPS()
	ftime2 = MilliSecs() 
	ftime3 = ftime2 - ftime1 
	ftime4 = fRate - ftime3 
	Delay ftime4 
	ftime1 = MilliSecs() 
	;DebugLog frate
End Function


;---------------------
Function MinXZDist#(ent1, x#, z#)
  xDist# = Abs(Abs(EntityX(ent1)) - Abs(x))
  zDist# = Abs(Abs(EntityZ(ent1)) - Abs(z))

  ;CFound  = Str(EntityX(ent1))+" : "+Str(EntityZ(ent1))

  If xDist > zDist
     Return xDist
  Else
     Return zDist
  EndIf
End Function

;---------------------
Function UpdateWater()
For a=0 To VertexCount-1 
Freq#=MilliSecs()/waterflow
   Vertex(a)\z#=Sin(freq+Vertex(a)\x#*300+Vertex(a)\y#*400)*wavesize
   VertexCoords surface,a,Vertex(a)\x#,Vertex(a)\y#,Vertex(a)\z#
Next

UpdateNormals watermesh

End Function


;=========================================
;========== FROM LANDS ===================
;=========================================
;================================================
Function LoadItems(LevelName$)

NumItems = 0

ClearInventory()

filein = ReadFile(LevelName)
;Local WallY# = TerrainY(terrain, 50,50,160)

While Not Eof(filein)
  Read1$ = ReadLine$( filein )
  If Mid(Read1$,1,1) <> ";" And (Read1$ <> "")
     Var$=GetStrParam$(Read1$,1)

      ; Any item - KEY, PLANT, WEAPON etc.
      If Var$="ITEM"   
        Items(NumItems) = New itemsinfo
        WallX% = Int(GetStrParam$(Read1$,3))
        WallZ% = Int(GetStrParam$(Read1$,4))
        WallY# = TerrainY(terrain, WallX,50,WallZ)
        Items(NumItems)\ItemModel = LoadMD2( GetStrParam$(Read1$,5))  ;model name
        EntityTexture Items(NumItems)\ItemModel, LoadTexture( GetStrParam$(Read1$,6) ) 
        ;cFound = GetStrParam$(Read1$,6)
        ScaleEntity Items(NumItems)\ItemModel, 0.2, 0.2, 0.2
        PositionEntity Items(NumItems)\ItemModel,WallX,WallY,WallZ
        RotateEntity Items(NumItems)\ItemModel,0,180,0
        EntityRadius Items(NumItems)\ItemModel, 1
        EntityPickMode Items(NumItems)\ItemModel,1
        NameEntity Items(NumItems)\ItemModel, GetStrParam$(Read1$,1)
        Items(NumItems)\oItem = LoadImage(GetStrParam$(Read1$,7))
        Items(NumItems)\ItemID = GetStrParam$(Read1$,2) 
        Items(NumItems)\ItemName = GetStrParam$(Read1$,8)
        Items(NumItems)\ItemDescription = GetStrParam$(Read1$,9)
        NumItems = NumItems + 1
      EndIf 
      ; 
      If Var$="TREE"   
         ;Tree
         WallX% = Int(GetStrParam$(Read1$,3))
         WallZ% = Int(GetStrParam$(Read1$,4))
         WallY# = TerrainY(terrain, WallX,50,WallZ)
         Angle% = Int(GetStrParam$(Read1$,5))
         tree = LoadMesh("MODELS\TREES\tree.B3D")
         FlipMesh tree
         ScaleEntity tree, 0.08, 0.08, 0.08
         RotateEntity tree, 0, Angle, 0 
         PositionEntity tree,WallX,WallY,WallZ
         EntityFX tree, 16+1
         EntityPickMode tree,1
;         HideEntity tree
      EndIf   


 EndIf
Wend
CloseFile( filein )
End Function

;==========================
Function ClearInventory()
  For i=0 To 20
     Inventory(i) = 0
  Next
End Function

;--------------------------
Function DrawInventory()
   DrawImage(gfxStatus, 0, 418 )
   For i=0 To 8 
      If Inventory(i)<>0
         DrawImage(Inventory(i), 215+i*42+5, 429 )
      EndIf
   Next
End Function

;=================================================================
Function CheckInventory(X, Y)
   lVal = False
   If (X>220) And (X<592) And (Y>432) And (Y<468)
      cInvPos = Int((X-215)/42)
      If lItemInHand
         If Inventory(cInvPos) <> 0
            tmpPic = CurrentItem
            CurrentItem = Inventory(cInvPos)
            CurrentModel = FindModel(CurrentItem) 
            Inventory(cInvPos) = tmpPic
            lItemInHand = True
            texSec = MilliSecs() 
            cObjectName = FindItemDescription(CurrentItem,2)
         Else
            Inventory(cInvPos) = CurrentItem 
            lItemInHand = False
         EndIf
      Else 
         If Inventory(cInvPos) <> 0
            CurrentItem = Inventory(cInvPos)
            CurrentModel = FindModel(CurrentItem) 
            Inventory(cInvPos) = 0
            lItemInHand = True
            texSec = MilliSecs() 
            cObjectName = FindItemDescription(CurrentItem,2)
         EndIf
      EndIf
      lVal = True
   EndIf
   Return lVal
End Function

;---------------------------
Function FindItem(ent)
  retV = 0
  For i=0 To ALL_ITEMS
     If Items(i)\ItemModel = ent
        retV = Items(i)\oItem ; Return 2D Image
        Exit
     EndIf
  Next
Return retV 
End Function


;---------------------------
Function FindItemName$(ItemPic)
  retName$ = ""
  For i=0 To NumItems-1
     If Items(i)\oItem = ItemPic
        retName = Items(i)\ItemName ; Return 2D Image
        ;CFound = Items(i)\ItemName     
        Exit
     EndIf
  Next
Return retName
End Function

;---------------------------
Function FindItemID$(ItemPic)
  retID$ = ""
  For i=0 To NumItems-1
     If Items(i)\oItem = ItemPic
        retID = Items(i)\ItemID ; Return Item Name
        Exit
     EndIf
  Next
Return retID
End Function

;---------------------------
Function FindItemPic(ItemName$)
  F